%bcond_without udev
%bcond_without firmware

%kmdl zaptel12

Summary: Digium FXS/FXO drivers
Name: zaptel12
Version: 1.2.27
Release: 47%{?dist}
Epoch: 1
License: GPL
Group: Applications/Internet
URL: http://www.asterisk.org/
Source0: http://downloads.asterisk.org/pub/telephony/zaptel/releases/zaptel-%{version}.tar.gz
# svn diff http://svn.digium.com/svn/zaptel/{tags/1.2.27,branches/1.2}
Patch0: zaptel-1.2-svn4587.patch
Patch1: zaptel-1.2.27-CLASS_DEV_CREATE.patch
Patch2: zaptel-1.2.27-hrtimer.patch
Patch3: zaptel-diet.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: newt-devel, /bin/ps
%{?with_udev:BuildRequires: %{_bindir}/udevinfo}
Requires: newt
Provides: zaptel-devices = %{evr}
Obsoletes: zaptel-devices < %{evr}
Obsoletes: zaptel < %{evr}
Conflicts: zaptel
#kmdl_parentdependencies

%description
Asterisk is a complete PBX in software. It runs on Linux and provides
all of the features you would expect from a PBX and more. If you want
to interface with POTS and are using Digium hardware, the Zaptel drivers
support these cards.

%if %{kmdl_userland}
%lib_package tonezone 1
%endif

%devel_extra_Obsoletes zaptel-devel < %{evr}
%devel_extra_Conflicts zaptel-devel

%package -n %kmdl_name
%kmdl_dependencies
Summary: Digium kernel drivers
Group: System Environment/Kernel
# For the device management
Requires: %{name} = %{evr}
Obsoletes: %{kmdl_nameof zaptel} < %{evr}
Conflicts: %{kmdl_nameof zaptel}

%description -n %kmdl_name
Asterisk is a complete PBX in software. It runs on Linux and provides
all of the features you would expect from a PBX and more. If you want
to interface with POTS and are using Digium hardware, the Zaptel drivers
support these cards.

%kmdl_desc

%prep
%setup -q -n zaptel-%{version}
%patch0 -p1 -b .svnfixes
%patch1 -p1 -b .CLASS_DEV_CREATE
%patch2 -p1 -b .hrtimer
%patch3 -p0 -b .diet
perl -pi -e's,/usr/lib,%{_libdir},g' Makefile
perl -pi -e's,%{_libdir}/hotplug,/usr/lib/hotplug,g' Makefile
perl -pi -e's,mknod,:,' Makefile
grep -rl '#include <linux/config.h>' . | xargs perl -pi -e's,#include <linux/config.h>,/* #include <linux/config.h> */,'

if test ! -f %{kmdl_kernelsrcdir}/include/asm/semaphore.h; then
  for x in wctc4xxp wctdm24xxp wcte12xp xpp; do
    perl -pi -e"s,$x/,," Kbuild
  done
fi

%build
%kmdl_config
%if %{kmdl_userland}
# KVERS needed for firmware decision
make programs libs KVERS=%{_kernel}
%else
make modules KSRC=%{kmdl_kernelsrcdir} KVERS=%{_kernel}
%endif

%install
rm -rf %{buildroot}
%if %{kmdl_userland}
mkdir -p %{buildroot}%{_mandir}/man8
mkdir -p %{buildroot}%{_sysconfdir}
mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d
mkdir -p %{buildroot}%{_sysconfigdir}
mkdir -p %{buildroot}%{_sysconfigdir}/network-scripts
mkdir -p %{buildroot}%{_initdir}
%if %{with firmware}
%if %{with udev}
mkdir -p %{buildroot}/lib/firmware
%else
mkdir -p %{buildroot}/usr/lib/hotplug/firmware
%endif
%endif
make install-programs devices firmware \
  DESTDIR=%{buildroot} LIBDIR=%{_libdir} \
  KSRC=%{kmdl_kernelsrcdir} KVERS=%{_kernel} \
  %{?with_udev:DYNFS=yes UDEVRULES=yes} \
  %{!?with_udev:DYNFS=}
make config DESTDIR=%{buildroot} CHKCONFIG=:
install -D -m 644 zaptel.sysconfig %{buildroot}%{_sysconfigdir}/zaptel
install -D -m 755 ifup-hdlc %{buildroot}%{_sysconfigdir}/network-scripts/ifup-hdlc
install -D -m 644 zaptel.conf.sample %{buildroot}%{_sysconfdir}/zaptel.conf
rm -f %{buildroot}%{_sysconfdir}/default/zaptel
%if %{with udev}
mv %{buildroot}/etc/udev/rules.d/*.rules %{buildroot}/etc/udev/rules.d/60-zaptel.rules
cat >> %{buildroot}/etc/udev/rules.d/60-zaptel.rules <<EOF
# workaround for udev ignoring rules with same NAME=
KERNEL=="zap*", OWNER="asterisk", GROUP="asterisk", MODE="0660"
EOF
test "`udevinfo -V | cut -f3 -d' '`" -le 54 \
  && sed -e's,KERNEL==,KERNEL=,' %{buildroot}/etc/udev/rules.d/60-zaptel.rules
%else
cat > zaptel.devices <<EOF
%defattr(0660,asterisk,asterisk,-)
%dir /dev/zap
%dev(c,196,0) /dev/zap/ctl
%dev(c,196,253) /dev/zap/timer
%dev(c,196,254) /dev/zap/channel
%dev(c,196,255) /dev/zap/pseudo
EOF
for i in `seq 1 250`; do
    echo "%dev(c,196,1) /dev/zap/$i" >> zaptel-devices.list
done
%endif

%else
mkdir -p %{buildroot}%{kmdl_moduledir}/drivers/%{name}
make install-modules DESTDIR=%{buildroot} \
  KSRC=%{kmdl_kernelsrcdir} KVERS=%{_kernel}
if [ -d %{buildroot}%{kmdl_moduledir}/../misc ]; then
  mv %{buildroot}%{kmdl_moduledir}/../misc/* %{buildroot}%{kmdl_moduledir}/drivers/%{name}
fi
if [ -d %{buildroot}%{kmdl_moduledir}/../extra ]; then
  mv %{buildroot}%{kmdl_moduledir}/../extra/* %{buildroot}%{kmdl_moduledir}/drivers/%{name}
fi
%endif

%post 
# Register the zaptel service
/sbin/chkconfig --add zaptel

%preun
if [ $1 = 0 ]; then
        /sbin/service zaptel stop > /dev/null 2>&1
        /sbin/chkconfig --del zaptel
fi

%post -n %kmdl_name
%kmdl_install

%postun -n %kmdl_name
%kmdl_remove

%clean
rm -rf %{buildroot}

%if %{kmdl_userland}

%files %{!?with_udev:-f zaptel.devices}
%defattr(-,root,root,-)
%doc LICENSE README*
%config(noreplace) %{_sysconfigdir}/zaptel
%config(noreplace) %{_sysconfdir}/zaptel.conf
%{_sysconfigdir}/network-scripts/ifup-hdlc
%{_initrddir}/zaptel
/sbin/ztcfg
/sbin/zttool
/sbin/fxotune
/sbin/torisatool
/sbin/ztmonitor
/sbin/ztspeed
/sbin/zttest
%{_mandir}/man8/ztcfg.8*
%{_mandir}/man8/zttool.8*
%{_mandir}/man8/fxotune.8*
%{_mandir}/man8/torisatool.8*
%{_mandir}/man8/ztmonitor.8*
%{_mandir}/man8/ztspeed.8*
%{_mandir}/man8/zttest.8*
%{?with_udev:/etc/udev/rules.d/*}
%if %{with firmware}
%if %{with udev}
/lib/firmware/*
%else
/usr/lib/hotplug/firmware/*
%endif
%endif

%else

%files -n %kmdl_name
%defattr(-,root,root,-)
%{kmdl_moduledir}

%endif

%changelog
* Thu Aug 13 2009 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.27-47
- Renamed to zaptel12.

* Sat Oct 11 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.27-46
- Update to 1.2.27.

* Sun Jun  1 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.26-45
- Update to 1.2.26.

* Tue Apr 22 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.25-44
- Update to 1.2.25.

* Tue Feb 19 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.24-43
- Update to 1.2.24.

* Tue Jan 15 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.23-42
- Update to 1.2.23.

* Sat Dec 22 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.22.1-41
- Update to 1.2.22.1.

* Fri Nov 30 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.22-40
- Update to 1.2.22.

* Mon Oct 29 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.21-39
- Update to 1.2.21.

* Tue Oct  9 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.20.1-38
- Update to 1.2.20.1.

* Sat Aug 18 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.20-37
- Update to 1.2.20.

* Sat Jul 21 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.19-36
- Update to 1.2.19.

* Wed Jun 13 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.18-35
- Update to 1.2.18.

* Wed Apr 25 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.17.1-33
- Update to 1.2.17.1

* Wed Mar 21 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.16-32
- Update to 1.2.16.

* Sat Mar  3 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.15-31
- Update to 1.2.15.

* Wed Feb 21 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.14-30
- Update to 1.2.14.

* Wed Feb 14 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.13-29
- Fix ownership for broken udev.

* Mon Feb 12 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.13-28
- Move udev rules to after default rules.

* Fri Feb  9 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.13-27
- update to 1.2.13.

* Sat Dec 16 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.12-25
- Update to 1.2.12.

* Thu Oct 26 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.10-22
- Fix udev rules (bug #1035), thanks to Mark Wormgoor.

* Wed Oct 25 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.10-21
- Rebuild w/o Fedora Extras to avoid beta bits.
- Bump epoch to superseed beta bits.

* Thu Oct 19 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1.2.10-19
- Update to 1.2.10.

* Sat Sep  9 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1.2.9-18
- Update to 1.2.9.

* Fri Aug 25 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1.2.8-17
- Update to 1.2.7.

* Sat Jul 15 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1.2.7-16
- Update to 1.2.7.

* Wed May 31 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.6.

* Mon Mar 27 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.5.

* Thu Feb 16 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.4.

* Fri Feb  3 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.3.

* Thu Jan 19 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.2.

* Mon Dec 12 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.1.

* Tue Oct 11 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.0.9.2.

* Thu Oct 06 2005 Mark Wormgoor <mark@wormgoor.com>
- Fix paths in zaptel.init.
- Fix compilation against 2.6.13 kernel.

* Fri Jul 15 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.0.9.

* Mon Jun 27 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.0.8.

* Mon Mar 07 2005 Mark Wormgoor <mark@wormgoor.com>
- Initial version
